Unit UClock;

Interface

Uses
  System.SysUtils, System.Classes, Windows, Messages;



Type
  TDelayClock = class(TComponent)

  Private
  { Private declarations }
	  FStart : Integer;
	  nPartTime: Integer;

  	st : Array[0..3] OF Integer;

  Protected
    { Protected declarations }
  Public
    { Public declarations }
    Constructor Create(AOwner : TComponent); override;

    Function  GetStart : Integer;
    Function  Time : STRING;

    Property Start : Integer read GetStart;

  Published
    { Published declarations }
End;



Procedure Register;

Implementation

Procedure Register;
begin
  RegisterComponents('Samples', [TDelayClock]);
end;

Constructor TDelayClock.Create (AOwner : TComponent);
Begin
	Inherited Create(AOwner);
	nPartTime := 0;
End;

Function TDelayClock.GetStart : Integer;
Begin
	If nPartTime < 3 Then inc(nPartTime);
	st[nPartTime] := GetTickCount;
End;

Function TDelayClock.Time : String;
Var
  iExpireTime   : Integer;
  hour, min     : Word;
  sec           : extended;
  tmp           : String;

Begin
  iExpireTime   := GetTickCount - st[nPartTime];
  hour          := iExpireTime  DIV 3600000;
  iExpireTime   := iExpireTime  MOD 3600000;
  min           := iExpireTime  DIV 60000;
  iExpireTime   := iExpireTime  MOD 60000;
  sec           := 0.001 * iExpireTime ;

  If hour > 0
  Then tmp := tmp + Format('%2.1d u %2.1d m %5.3f s', [hour, min, sec])
  Else
    If min > 0
    Then tmp := tmp + Format('%2.1d m %5.3f s', [min, sec])
    Else tmp := tmp + Format('%5.3f s', [sec]);

  Result := tmp;
  dec(nPartTime);
End;

end.
