program camera;

{$mode objfpc}

uses
  JS, Web;

Type
  TCameraApp = class
    video : TJSHTMLVideoElement;
    canvas : TJSHTMLCanvasElement;
    context : TJSCanvasRenderingContext2D;
    startbutton : TJSHTMLElement;
    stillbutton : TJSHTMLElement;
    function StartStream(JS : JSValue) : JSValue;
    function DoError(JS : JSValue) : JSValue;
    Procedure StartVideo(Event: TJSEvent);
    Procedure CreateStill(Event: TJSEvent);
    procedure Run;
  end;

function TCameraApp.StartStream(JS : JSValue) : JSValue;
begin
  Result:=Undefined;
  video.srcObject:=TJSHTMLMediaStream(JS);
  video.play();
end;

function TCameraApp.DoError(JS : JSValue) : JSValue;

begin
  Result:=Undefined;
  console.log('An error occurred: ' + String(JS));
end;

Procedure TCameraApp.StartVideo(Event: TJSEvent);

var
  constraints : TJSMediaConstraints;

begin
  constraints:=TJSMediaConstraints.new;
  constraints.video:=True;
  constraints.audio:=False;
  Window.navigator.mediaDevices.getUserMedia(constraints)
      ._then(@StartStream)
      .catch(@DoError)
end;

Procedure TCameraApp.CreateStill(Event: TJSEvent);

begin
  canvas.width:=video.clientWidth;
  canvas.height:=video.clientHeight;
  context.drawImage(video, 0, 0, video.clientWidth, video.clientHeight);
end;


Procedure TCameraApp.Run;

begin
  video:=TJSHTMLVideoElement(document.getElementById('video'));
  canvas:=TJSHTMLCanvasElement(document.getElementById('canvas'));
  context:=TJSCanvasRenderingContext2D(canvas.getContext('2d'));

  startbutton:=TJSHTMLElement(document.getElementById('start'));
  startbutton.innerText:='Start video';
  startbutton.addEventListener('click', @startvideo);


  stillbutton:=TJSHTMLElement(document.getElementById('still'));
  stillbutton.innerText:='Create still';
  stillbutton.addEventListener('click', @createstill);
end;

begin
  With TCameraApp.Create do
    Run;
end.
