program camera;

{$mode objfpc}

uses
  BrowserConsole, JS, Classes, SysUtils, Web, WasiEnv, WasiHostApp, JOB_Browser, JOB_Shared;

Type
  { TMyApplication }

  TMyApplicatioan = class(TBrowserWASIHostApplication)
  Private
    FJOB: TJSObjectBridge;
    function OnBeforeStart(Sender: TObject;
      aDescriptor: TWebAssemblyStartDescriptor): Boolean;
  Public
    constructor Create(aOwner : TComponent); override;
    procedure DoRun; override;
  end;

function TMyApplication.OnBeforeStart(Sender: TObject;
  aDescriptor: TWebAssemblyStartDescriptor): Boolean;
begin
  FJOB.WasiExports:=aDescriptor.Exported;
  Result:=true;
end;

constructor TMyApplication.Create(aOwner: TComponent);
begin
  inherited Create(aOwner);
  FJOB:=TJSObjectBridge.Create(WasiEnvironment);
  RunEntryFunction:='_initialize';
end;

procedure TMyApplication.DoRun;

var
  wasm : String;

begin
  Terminate;
  // Allow to load file specified in hash: index.html#mywasmfile.wasm
  Wasm:=ParamStr(1);
  if Wasm='' then
    Wasm:='wasmcamera.wasm';
  StartWebAssembly(Wasm,true,@OnBeforeStart);
end;

var
  Application : TMyApplication;

begin
  Application:=TMyApplication.Create(nil);
  Application.Initialize;
  Application.Run;
end.
